<?php

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
    echo json_encode(['status' => false, 'message' => 'Invalid request method']);
    exit;
}

$data = json_decode(file_get_contents('php://input'), true);
if (!$data) {
    $data = $_POST;
}

if (!isset($data['op']) || $data['op'] !== 'login') {
    echo json_encode(['status' => false, 'message' => 'Invalid operation']);
    exit;
}

$url = null;

if (isset($data['url']) && !empty($data['url'])) {
    $url = $data['url'];
} elseif (isset($data['ip'], $data['user'], $data['pwd'])) {
    $ip = rtrim($data['ip'], '/');
    $user = urlencode($data['user']);
    $pwd = urlencode($data['pwd']);
    $url = "{$ip}/player_api.php?username={$user}&password={$pwd}";
} else {
    echo json_encode(['status' => false, 'message' => 'Missing parameters']);
    exit;
}

$response = fetch_url($url);

if ($response && isset($response['user_info']) && $response['user_info']['status'] !== 'Expired') {
    echo json_encode(['status' => true, 'data' => $response]);
} else {
    echo json_encode(['status' => false, 'message' => 'Not working']);
}

function fetch_url($url)
{
    $ch = curl_init();

    curl_setopt_array($ch, [
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_TIMEOUT => 5,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_SSL_VERIFYHOST => false,
        CURLOPT_SSL_VERIFYPEER => false,
    ]);

    $result = curl_exec($ch);
    $error = curl_error($ch);

    curl_close($ch);

    if ($error) {
        return false;
    }

    $json = json_decode($result, true);
    return $json;
}
?>