<?php
// إعداد الهيدر باش يرجع JSON
header('Content-Type: application/json');

// إعداد المسار اللي غادين نخزنو فيه الملفات
$uploadDir = 'uploads/';
if (!file_exists($uploadDir)) {
    mkdir($uploadDir, 0777, true);
}

$response = [
    'status' => 0,
    'message' => 'An error occurred.',
];

try {
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        
        if (isset($_FILES['file_attachment'])) {
            // التعامل مع رفع الملف
            $file = $_FILES['file_attachment'];

            $fileName = basename($file['name']);
            $targetFile = $uploadDir . uniqid() . '_' . $fileName;

            // التحقق من صيغة m3u
            if (pathinfo($fileName, PATHINFO_EXTENSION) !== 'm3u') {
                throw new Exception('Only M3U files are allowed.');
            }

            if (move_uploaded_file($file['tmp_name'], $targetFile)) {
                $response = [
                    'status' => 1,
                    'message' => 'File uploaded successfully.',
                    'link' => $targetFile
                ];
            } else {
                throw new Exception('Failed to move uploaded file.');
            }

        } elseif (isset($_POST['link'])) {
            // التعامل مع إضافة رابط مباشر
            $link = filter_var($_POST['link'], FILTER_SANITIZE_URL);
            if (empty($link)) {
                throw new Exception('Invalid link.');
            }

            // تحميل محتوى الرابط وحفظه كملف
            $fileContent = file_get_contents($link);
            if ($fileContent === false) {
                throw new Exception('Failed to fetch link content.');
            }

            $fileName = uniqid() . '_downloaded.m3u';
            $targetFile = $uploadDir . $fileName;

            if (file_put_contents($targetFile, $fileContent)) {
                $response = [
                    'status' => 1,
                    'message' => 'Link fetched and saved successfully.',
                    'link' => $targetFile
                ];
            } else {
                throw new Exception('Failed to save fetched file.');
            }
        } else {
            throw new Exception('No file or link provided.');
        }

    } else {
        throw new Exception('Invalid request method.');
    }
} catch (Exception $e) {
    $response['message'] = $e->getMessage();
}

// رجع الرد بصيغة JSON
echo json_encode($response);